Bug 1463692 - glibc: Incorrect pointer alignment in NSS group merge result construction
Summary: glibc: Incorrect pointer alignment in NSS group merge result construction
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: glibc
Version: 7.5
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: DJ Delorie
QA Contact: Sergey Kolosov
URL:
Whiteboard:
Depends On: 1471985
Blocks: 1473718
TreeView+ depends on / blocked
 
Reported: 2017-06-21 14:02 UTC by Florian Weimer
Modified: 2018-04-10 14:01 UTC (History)
8 users (show)

Fixed In Version: glibc-2.17-197.el7
Doc Type: Bug Fix
Doc Text:
Cause: Users with [SUCCESS=MERGE] in /etc/nsswitch.conf may see incorrectly merged group query results. On some platforms (s390x and powerpc64), it may (rarely) crash. Fix: glibc has been fixed to correctly merge group records. Result: Queries to merged group databases should return correctly merged records.
Clone Of:
: 1471985 (view as bug list)
Environment:
Last Closed: 2018-04-10 14:00:52 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Bugzilla 1298975 high CLOSED [RFE] Backport the groups merging feature 2020-10-14 00:28:05 UTC
Red Hat Product Errata RHSA-2018:0805 None None None 2018-04-10 14:01:54 UTC
Sourceware 21654 None None None 2019-07-23 09:11:44 UTC

Internal Links: 1298975

Description Florian Weimer 2017-06-21 14:02:55 UTC
Sergey Kolosov discovered that the NSS group merge feature (added in bug 1298975) does not work on ppc64 and s390x.  The cause seems to be this code in grp/grp-merge.c:

  /* Copy the pointers from the members array into the buffer and assign them
     to the gr_mem member of destgrp.  */
  destgrp->gr_mem = (char **) &destbuf[c];
  len = sizeof (char *) * (memcount + 1);
  BUFCHECK (len);
  memcpy (&destbuf[c], members, len);
  c += len;
  free (members);
  members = NULL;

After the assigned to destgrp->gr_mem, we have:

(gdb) print destbuf
$1 = 0x10031000 "groupa"
(gdb) print c
$2 = 21
(gdb) print destgrp->gr_mem
$3 = (char **) 0x10031015

This pointer is not suitable aligned, and this triggers undefined behavior.

We should switch this code over to the allocation buffer interface, which deals with exactly this kind of problem.

Comment 1 Carlos O'Donell 2017-06-21 14:47:50 UTC
Correct, gr_mem is not sufficiently aligned at the start.

On pcc64 any * must be doubleword aligned (8 bytes).
On s390 any * must be word aligned (4 bytes).

These are just natural alignment rules.

Comment 2 Carlos O'Donell 2017-07-20 08:58:02 UTC
Absolutely needs to be fixed and is already fixed in upstream master:

commit f8cef4d07d9641e27629bd3ce2d13f5d702fb251
Author: DJ Delorie <dj@delorie.com>
Date:   Wed Jul 19 13:14:34 2017 -0400

    Fix cast-after-dereference
    
    Original code was dereferencing a char*, then casting the value
    to size_t.  Should cast the pointer to size_t* then deference.

commit 4fa8ae49aa169fb8d97882938e8bee3ed9ce5410
Author: DJ Delorie <dj@delorie.com>
Date:   Fri Jul 14 21:46:42 2017 -0400

    Fix BZ #21654 - grp-merge.c alignment
    
    * grp/grp_merge.c (__copy_grp): Align char** to minimum pointer
    alignment not char alignment.
    (__merge_grp): Likewise.

Comment 4 Florian Weimer 2017-10-02 14:43:58 UTC
Note that comment 2 shows the real fix, I think the alignment wasn't the actual cause of the bug.  We need all three commits, including:

commit 4fa8ae49aa169fb8d97882938e8bee3ed9ce5410
Author: DJ Delorie <dj@delorie.com>
Date:   Fri Jul 14 21:46:42 2017 -0400

    Fix BZ #21654 - grp-merge.c alignment
    
    * grp/grp_merge.c (__copy_grp): Align char** to minimum pointer
    alignment not char alignment.
    (__merge_grp): Likewise.

Comment 8 errata-xmlrpc 2018-04-10 14:00:52 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:0805


Note You need to log in before you can comment on or make changes to this bug.